import java.util.ArrayList;
import java.lang.reflect.Array;

/**
 * Eine Klasse zur Verwaltung eines Graphen
 * Version ohne grafische Darstellung
 * 
 * @author claus albowski
 * @version (maerz 2020)
 */
public class Graph
{
    private ArrayList<Knoten> dieKnoten;
    private ArrayList<Kante> dieKanten;

    /**
     * Erzeuge einen neuen leeren Graphen
     */
    public Graph()
    {
        dieKnoten = new ArrayList();
        dieKanten = new ArrayList();
    }
    
    public ArrayList<Knoten> gibKnoten() {return dieKnoten;}
    public ArrayList<Kante> gibKanten() {return dieKanten;}

    /**
     * erzeugeKnoten
     */
    public void erzeugeKnoten(String[] namen) {
        for (String name : namen)
        neuerKnoten(name);
    }
    
    /**
     * erzeugeKanten
     */
    public void erzeugeKanten(String[] von, String[] nach, int[] laengen) {
        int anzahl=Array.getLength(von);
        if (anzahl!=Array.getLength(nach)) return;
        if (anzahl!=Array.getLength(laengen)) return;
        for (int i=0; i<anzahl;i++)
        neueKante(von[i],nach[i],laengen[i]);
    }
    
    /**
     * neuer Knoten
     * erzeugt zum uebergebenen Namen einen Knoten,
     * wenn der Name nicht doppelt ist
     */
    public void neuerKnoten(String name) {
        for (Knoten knoten : dieKnoten)
        if (name.equals(knoten.gibNamen())) return;
        dieKnoten.add(new Knoten(name));
    }
    
    /**
     * neue Kante
     * erzeugt zu zwei uebergebenen Knotennamen
     * eine neue Kante, wenn sie nicht bereits existiert
     */
    public void neueKante(String derEine, String derAndere, int laenge) {
        if (hatKante(derEine, derAndere)) return;
        if (hatKante(derAndere, derEine)) return;
        Knoten knoten1 = gibKnoten(derEine);
        Knoten knoten2 = gibKnoten(derAndere);
        dieKanten.add(new Kante(knoten1, knoten2, laenge));
    }
    
    /**
     * gibt zu einem Namen den Knoten zurueck
     */
    public Knoten gibKnoten(String name) {
        for (Knoten knoten : dieKnoten)
        if (name.equals(knoten.gibNamen())) return knoten;
        return null;
    }
    
    /**
     * prueft, ob die Kante bereits existiert
     */
    private boolean hatKante(String derEine, String derAndere) {
        for (Kante kante : dieKanten)
        if (derEine.equals(kante.gibVon()))
        if (derAndere.equals(kante.gibNach()))
        return true;
        for (Kante kante : dieKanten)
        if (derEine.equals(kante.gibNach()))
        if (derAndere.equals(kante.gibVon()))
        return true;
        return false;
    }
    
        
//     /**
//      * verknuepft alle Knoten zu einem Graphen.
//      */
//     public void vollstaendig(){
//         for (Knoten knoten1 : dieKnoten)
//         for (Knoten knoten2 : dieKnoten)
//         if (!knoten1.gibNamen().equals(knoten2.gibNamen()))
//         neueKante(knoten1,knoten2);
//     }
    
}

